import sys
from language_functions import language_functions
import os
import codecs
import numpy as np
import time as time
import datetime
import matplotlib.pyplot as plt

folderpath = sys.argv[1]
master_database = sys.argv[2]
files_list = [f for f in os.listdir(folderpath) if os.path.isfile(os.path.join(folderpath, f))]
today = datetime.date.today()
destination_folder_name = str(today) + '_' + str(time.time()) + '_text_vs_master'
if not os.path.exists(str(
        os.getcwd()) + '/output_data/' + destination_folder_name):  # test to se if a folder for storing the data exists
    os.makedirs(str(os.getcwd()) + '/output_data/' + destination_folder_name)  # if no , create the folder
    data_path = str(os.getcwd()) + '/output_data/' + destination_folder_name


log_ranking_list = np.zeros((len(files_list)))
name_list = []
for item in range(0,len(files_list)):
    textname_split = language_functions.delimit_file_text(files_list[item])
    name_list.append(textname_split[-2])
    print '\r\n' + files_list[item]
    # RawlingsNumber, r_value = language_functions.analyze(join(folderpath, files_list[item]), master_database)
    log_rank = language_functions.get_databaselogranks_of_readinput(os.path.join(folderpath, files_list[item]), master_database, destination_path=data_path)
    log_ranking_list[item] = log_rank


print name_list
y_pos = np.arange(len(name_list))
log_ranking_list, name_list = (list(x) for x in zip(*sorted(zip(log_ranking_list, name_list))))

with codecs.open(data_path + '/log_ranking_list.txt', "w", encoding="utf-8") as f:
    for item in range(0,len(files_list)):
        f.write(name_list[item] + ', ' + str(log_ranking_list[item]) + '\r\n')

plt.bar(y_pos, log_ranking_list, align='center', color='k')
plt.xticks(y_pos, name_list,rotation='vertical')
plt.ylabel('rank')
plt.title('difficulty of texts')
plt.subplots_adjust(bottom=0.6)
x1,x2,y1,y2 = plt.axis()
plt.axis((x1,x2,np.min(log_ranking_list),np.max(log_ranking_list)))
today = datetime.date.today()
file_name = data_path + '/_' + str(today) + '__' + str(time.time()) + 'master_rankings' + ".png"
plt.savefig(file_name)
plt.close()

#language_functions.analyze_word_frequency(master_database)

